# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Testing.V1.Model.ApkManifest do
  @moduledoc """
  An Android app manifest. See http://developer.android.com/guide/topics/manifest/manifest-intro.html

  ## Attributes

  *   `applicationLabel` (*type:* `String.t`, *default:* `nil`) - User-readable name for the application.
  *   `intentFilters` (*type:* `list(GoogleApi.Testing.V1.Model.IntentFilter.t)`, *default:* `nil`) - 
  *   `maxSdkVersion` (*type:* `integer()`, *default:* `nil`) - Maximum API level on which the application is designed to run.
  *   `minSdkVersion` (*type:* `integer()`, *default:* `nil`) - Minimum API level required for the application to run.
  *   `packageName` (*type:* `String.t`, *default:* `nil`) - Full Java-style package name for this application, e.g. "com.example.foo".
  *   `targetSdkVersion` (*type:* `integer()`, *default:* `nil`) - Specifies the API Level on which the application is designed to run.
  *   `usesPermission` (*type:* `list(String.t)`, *default:* `nil`) - Permissions declared to be used by the application
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :applicationLabel => String.t() | nil,
          :intentFilters => list(GoogleApi.Testing.V1.Model.IntentFilter.t()) | nil,
          :maxSdkVersion => integer() | nil,
          :minSdkVersion => integer() | nil,
          :packageName => String.t() | nil,
          :targetSdkVersion => integer() | nil,
          :usesPermission => list(String.t()) | nil
        }

  field(:applicationLabel)
  field(:intentFilters, as: GoogleApi.Testing.V1.Model.IntentFilter, type: :list)
  field(:maxSdkVersion)
  field(:minSdkVersion)
  field(:packageName)
  field(:targetSdkVersion)
  field(:usesPermission, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.Testing.V1.Model.ApkManifest do
  def decode(value, options) do
    GoogleApi.Testing.V1.Model.ApkManifest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Testing.V1.Model.ApkManifest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
